
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

// this is the automated version - 4 digit numbers with digits 0 to 9, no
// duplicates.

// returns 0 if there are duplicate digits otherwise returns 1
int nodup(int x) {
 char buff[5];int i,j;
 snprintf(buff,5,"%04d",x);
 for (i=0;i<3;++i) {
  for (j=i+1;j<4;++j) {
   if (buff[i]==buff[j]) return 0;
  }}
 return 1;
 }

int score(int x,int y) { // count bulls and cows and return 10*b+c
 char s1[5],s2[5];int i,j,b,c;
 b=c=0;
 snprintf(s1,5,"%04d",x);snprintf(s2,5,"%04d",y);
 for (i=0;i<4;++i) {
  for (j=0;j<4;++j) {
   if (s1[i]==s2[j]) {
    if (i==j) ++b;else ++c;
    break;
  }}}
 return 10*b+c;
 }

void showtime(void) {
 time_t current_time; char* c_time_string;
 current_time = time(NULL);
 /* Convert to local time format. */
 c_time_string = ctime(&current_time);
 printf("\nCurrent time is %s\n", c_time_string);
 }

int main(int argc,char *argv[]) {

 printf("\nentropya.c - tct - 6/7/16");
 printf("\nusage: entropya -noentropy -num n\n");

 int sc[41],ar[5040],sar[5040],counts[5040][14];
 int gs,scr,tttries,ttries[10],sn,ia,ea[5040],e;
 int i,k,j,m,tries,maxm,b,c;
 int noentropy=0,num=100; // controls number of numbers processed
 double minm,entropy[5040],cnt,s1=0,s2=0,sd;

 for (i=1;i<argc;i++) {
  if (strcmp(argv[i],"-noentropy")==0) noentropy=1;
  if (strcmp(argv[i],"-num")==0) num=atoi(argv[++i]);
  }

// encode the scores : number of bulls is multiplied by 10 and added to
// number of cows

 sc[40]=0;sc[30]=1;sc[20]=2;sc[21]=3;sc[22]=4;sc[10]=5;sc[11]=6;
 sc[12]=7;sc[13]=8;sc[0]=9;sc[1]=10;sc[2]=11;sc[3]=12;sc[4]=13;
 
 tttries=0;
 for (i=1;i<=9;++i) ttries[i]=0;
 m=-1;
 for (i=0123;i<=9876;++i) if (nodup(i)) sar[++m]=i;
 srand(time(NULL));
 showtime();

 for (ia=0;ia<num;++ia) {

 sn=sar[rand()%5040];
 for (i=0;i<=5039;++i) ar[i]=sar[i];
 maxm=5039;tries=1;
 gs=sar[rand()%5040];

 while (1) { // keep going till you have 4 bulls

  scr=score(gs,sn);
  if (scr==40) {
   printf("%04d %d ",gs,tries);
   if (ia%10==9) printf("\n");
   break;
   }
  m=-1;
  for (i=0;i<=maxm;++i) {
   // reload array with numbers that have the right score
   if (scr==score(gs,ar[i])) ar[++m]=ar[i];
   }
  maxm=m; // update the upper limit of the array index
  if (noentropy) {
   if (maxm==0) gs=ar[0];else gs=ar[rand()%maxm];
   }
  else {
  minm=pow(10,9);
  for (i=0;i<=maxm;++i) {
   for (j=0;j<=13;++j) counts[i][j]=0;
   for (k=0;k<=maxm;++k) ++counts[i][sc[score(ar[k],ar[i])]];
   entropy[i]=0;
   // compute entropy
   for (j=0;j<=13;++j) {
    cnt=counts[i][j];if (cnt>1) entropy[i]+=cnt*log(cnt);
    }
   if (entropy[i]<=minm) {
    if (entropy[i]<minm) {e=0;minm=entropy[i];}
    ea[e++]=ar[i];
    }
   } /* end for */
  gs=ea[rand()%e]; // pick a random one
  } /* end else */
  ++tries;
  } /* end while */

 ttries[tries]+=1;
 } /* end for */

 showtime();
 for (i=1;i<=9;++i) {
  s1+=ttries[i]*pow(i,2);
  s2+=ttries[i]*i;
  printf("%d %d\n",i,ttries[i]);
  tttries+=i*ttries[i];
  }
 sd=(num*s1-pow(s2,2))/(num*(num-1));
 sd=pow(sd,.5);
 printf("\nAverage number of tries : ");
 printf("%1.3f.\n",(double)tttries/num);
 printf("Standard deviation : %1.3f.\n",sd);
 return 0;

 }

